import os

import axipy
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog

from LoggerMws.Test.TestTask.add_cls import SimpleTask
from datetime import datetime

class DlgStartStop(QDialog):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.ui=self.load_ui("dlgTestStartStop.ui",self)
        self.ui.pb_start.clicked.connect(self.__start)
        self.ui.pb_stop.clicked.connect(self.__stop)
        self.__cls_alarm=SimpleTask(20)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def show(self):
        self.ui.show()
    def __start(self):
        self.__cls_alarm.signal_alarm.connect(self.__handler_alarm)
        self.__task = axipy.Task(self.__cls_alarm.startProc)
        self.__task.start()
    def __stop(self):
        self.__cls_alarm.isEnd=True
        self.__task.cancel()
    def __handler_alarm(self):
        print(
            '1: test-{date:%Y-%m-%d_%H:%M:%S}.txt'.format(date=datetime.now())
        )
