import axipy
from PySide2.QtCore import QObject, QTimer

from LoggerMws.ui.add_helper.add_cls_timer import fnc_open_mws, fnc_open_file, ActionsAxySignal
from LoggerMws.ui.add_helper.dbSqlite import DbSqlite
from LoggerMws.ui.add_helper.db_logger import DbLogger
from datetime import datetime

from LoggerMws.ui.add_helper.db_logger_qtimer import DbLoggerTimer
from LoggerMws.ui.add_helper.dlgLoggerMws import DlgLoggerMws


class MwsLogger(QObject):
    __folder_autoSave="LoggerMws"
    __name_file_db_logger="db_logger_mws"
    def __init__(self,parent):
        super().__init__(parent)
        self.__initDb()
        self.__isStart=False
        #self.__cls_logger=DbLogger(self.__db,1,True,parent)
        self.__dlg_conttolMws=DlgLoggerMws(parent)
        self.__dlg_conttolMws.start_signal.connect(self.__start_stop)
        self.__cls_logger=DbLoggerTimer(self.__db,1,False,parent)
        action_name = {}
        action_name['OpenWorkspace'] = fnc_open_mws
        action_name['CloseAll'] = None
        action_name['OpenFile'] = fnc_open_file
        action_name['SaveWorkspace'] = fnc_open_mws

        self.__cls_axipy_action = ActionsAxySignal(action_name, parent)
        self.__cls_axipy_action.extrenal_action.connect(self.__action_axipy)
        #self.__cls_logger=DbLoggerMws(1)
        #self.__cls_logger =DemoTimer(30000)
    @staticmethod
    def getFolderLoggerMws():
        path_user_folder = axipy.CurrentSettings.UserDataFolder
        path_folder_logger = path_user_folder.joinpath("LoggerMws")
        return str(path_folder_logger)

    def __action_axipy(self,name_action,add_info):
        self.__cls_logger.writeExternalEvent(name_action,add_info)
    def __start_stop(self,isStart,interval):
        if isStart:
            #self.__cls_logger.start(interval)
            self.__cls_logger.start(1)
            self.__isStart=True
        else:
            self.__cls_logger.stop()
            self.__isStart=False

    @property
    def IsStart(self):
        return self.__isStart
    def __initDb(self):
        path_user_folder=axipy.CurrentSettings.UserDataFolder
        path_folder_logger=path_user_folder.joinpath(self.__folder_autoSave)
        if not path_folder_logger.exists():
            path_folder_logger.mkdir()
        curent_name_db=self.__name_file_db_logger+"_"+datetime.now().strftime("%Y_%m_%d")+".db"
        self.__path_db=path_folder_logger.joinpath(curent_name_db)
        new_db=self.__path_db.exists()
        self.__db=DbSqlite(str(self.__path_db))
        self.__db.connect()
        if not new_db:
            sql_create="CREATE TABLE [journal](  [id] INTEGER PRIMARY KEY AUTOINCREMENT UNIQUE,  [дата] DATE,  [время] TIME,  [метка] TEXT, [add_info] TEXT, [mws] BLOB_TEXT)"
            self.__db.runSqlNoResult(sql_create)
            sql_create_view="CREATE VIEW [jornel_view] AS SELECT [id],[дата],[время],[метка],[add_info] FROM   [journal] ORDER  BY [время] DESC"
            self.__db.runSqlNoResult(sql_create_view)
    def show(self):
        self.__dlg_conttolMws.exec_()


