import axipy
from PySide2.QtCore import QObject, QTimer, Signal
from datetime import datetime

from LoggerMws.ui.add_helper.add_cls_timer import TimerTask


def minInSec(val_min):
    return int(val_min*60)
def getDataAndTime():
    now=datetime.now()
    str_date= now.strftime("%Y-%m-%d")
    str_time=now.strftime("%H:%M:%S")
    return str_date,str_time
class DbLogger(QObject):

    def __init__(self,db,interval=5,start=True,parent=None):
        super().__init__(parent)
        self.__intreval=minInSec(interval)
        self.__db=db
        self.__last_mws=None
        self.__status_start=start
        self.__initTimer(start)
        self.__writeMws("start")
    def __initTimer(self,isStart):

        self.__taskTimer=TimerTask(self.__intreval)
        if isStart:
            print(
                ' timer start-{date:%Y-%m-%d_%H:%M:%S}'.format(date=datetime.now())
            )
            self.__taskTimer.signal_alarm.connect(self.__handler_timer)
            self.__task = axipy.Task(self.__taskTimer.startProc)
            self.__task.start()

    def __handler_timer(self):
        self.__writeMws("timer")
        print(
            ' test-{date:%Y-%m-%d_%H:%M:%S}'.format(date=datetime.now())
        )
    def __writeMws(self,label):
        mws_curent=axipy.Workspace().save_string()
        isnotEq=True
        if self.__last_mws is None:
            self.__last_mws=mws_curent
        else:
            if self.__last_mws==mws_curent:
                isnotEq=False
        if isnotEq:
            self.__last_mws=mws_curent
            sql_insert = "insert into journal ([дата],[время],[метка],[mws]) values(?,?,?,?)"
            date_str, time_str = getDataAndTime()

            params = (date_str, time_str, label, self.__last_mws)
            self.__db.insertTransaction(sql_insert, params)
    def start(self):
        self.__cls_alarm.signal_alarm.connect(self.__handler_timer)
        self.__task = axipy.Task(self.__taskTimer.startProc)
        self.__task.start()
    def stop(self):
        self.__status_start=False
        self.__taskTimer.signal_alarm.disconnect(self.__handler_timer())
        self.__cls_alarm.isEnd = True
        self.__task.cancel()

    def writeExternalEvent(self,label):
        if self.__status_start:
            self.__writeMws(label)




