import axipy
from PySide2.QtCore import QObject, QTimer, Signal
from datetime import datetime
def minInMs(val_min):
    return int(val_min*60000)
def getDataAndTime():
    now=datetime.now()
    str_date= now.strftime("%Y-%m-%d")
    str_time=now.strftime("%H:%M:%S")
    return str_date,str_time
class DbLoggerTimer(QObject):

    def __init__(self,db,interval=5,start=True,parent=None):
        super().__init__(parent)
        self.__intreval=minInMs(interval)
        self.__db=db
        self.__last_mws=None
        self.__status_start=start
        self.__initTimer(start)
        self.__writeMws("start",None)
    def __initTimer(self,isStart):

        self.__timer = QTimer()
        #self.__timer.setInterval(self.__intreval)
        self.__timer.setInterval(self.__intreval)
        self.__timer.timeout.connect(self.handelr_timer)
        #self.__timer.timeout.connect(demo_timer_handler)
        if isStart:
            print(
                ' timer start-{date:%Y-%m-%d_%H:%M:%S}'.format(date=datetime.now())
            )
            self.__timer.start()

    def handelr_timer(self):
        self.__writeMws("timer",None)
        print(
            ' test-{date:%Y-%m-%d_%H:%M:%S}'.format(date=datetime.now())
        )
    def __writeMws(self,label,add_info):
        mws_curent=axipy.Workspace().save_string()
        isnotEq=True
        if self.__last_mws is None:
            self.__last_mws=mws_curent
        else:
            if self.__last_mws==mws_curent:
                isnotEq=False
        if isnotEq:
            self.__last_mws=mws_curent
            sql_insert = "insert into journal ([дата],[время],[метка],[add_info],[mws]) values(?,?,?,?,?)"
            date_str, time_str = getDataAndTime()

            params = (date_str, time_str, label,add_info, self.__last_mws)
            self.__db.insertTransaction(sql_insert, params)
    def start(self,interval):
        self.__status_start=True
        if interval is not None:
            self.__intreval = minInMs(interval)
        self.__timer.setInterval(self.__intreval)
        self.__writeMws("start", None)
        self.__timer.start()
    def stop(self):
        self.__status_start=False
        self.__timer.stop()
    def writeExternalEvent(self,label,add_info):
        if self.__status_start:
            self.stop()
            self.__writeMws(label,add_info)
            self.start(None)






