import os

from PySide2.QtCore import QFile, Signal
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog, QVBoxLayout

from LoggerMws.ui.add_helper.widgetTableDb import TableViewWidget


class DlgLoggerMws(QDialog):
    start_signal=Signal(bool,int)
    def __init__(self,parent=None):
        super().__init__(parent)
        self.ui=self.load_ui("dlgLoggerMws1.ui",parent)
        self.ui.finished.connect(self.__close_dlg)
        self.ui.pb_start.clicked.connect(self.__start)
        self.ui.pb_stop.clicked.connect(self.__stop)
        self.ui.tabWidget.removeTab(1)

        #self.__widgetJournalView = TableViewWidget(self.ui.tabWidget.widget(1))
        self.__widgetJournalView = TableViewWidget(self.ui.tabWidget)
        self.ui.tabWidget.setTabText(1, "Востановление mws")
        #self.ui.tabWidget.addTab(self.__widgetJournalView,"Востановление mws")
        #self.__layout_tab2 = QVBoxLayout()
        #self.__layout_tab2.setContentsMargins(10, 10, 10, 10)
        #self.ui.verticalLayout_tab_db.addWidget(self.__widgetJournalView)
        #self.__layout_tab2.addWidget(self.__widgetJournalView)
        #self.ui.tabWidget.widget(1).setLayout(self.__layout_tab2)
        self.ui.tabWidget.currentChanged.connect(self.__change_tab)
        #self.ui.tabWidget.setTabEnabled(1, True)

        jkl=0
    def exec_(self):
        self.ui.exec_()
    def __close_dlg(self):
        self.__widgetJournalView.closeDb()
    def __start(self):
        self.ui.pb_stop.setEnabled(True)
        self.ui.pb_start.setEnabled(False)
        self.ui.tabWidget.setTabEnabled(1,False)
        curent_interval=self.ui.spinBoxInterval.value()
        self.start_signal.emit(True, int(curent_interval))
    def __stop(self):
        self.ui.pb_stop.setEnabled(False)
        self.ui.pb_start.setEnabled(True)
        self.ui.tabWidget.setTabEnabled(1, True)
        self.start_signal.emit(False,0)
    def __change_tab(self,index):
        if index==1:
            self.__widgetJournalView.initDataWidget()
        else:
            self.__widgetJournalView.closeDb()
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
